/*
  Copyright (C) 2000 Xavier Hosxe <xhosxe@free.fr>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <stdio.h>
#include "elem.hpp"
#include "list.hpp"


void Elem::RemoveMe(void) 
{
    mlist->DecMnumber();

    if (mprev)
        mprev->mnext=mnext; 
    else
        mlist->mfirst=mnext;

    if (mnext)
        mnext->mprev=mprev;
    else
        mlist->mlast=mprev;

    if (mlist->mcurrent == this)
        mlist->mcurrent = mlist->mfirst;
}
